git-rebase.shon commit Test 'git add' for unmerged entries when core.symlinks=false. (05dcd69)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git-ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        if ! git-diff-index --quiet HEAD
  63        then
  64                if ! git-commit -C "`cat $dotest/current`"
  65                then
  66                        echo "Commit failed, please do not call \"git commit\""
  67                        echo "directly, but instead do one of the following: "
  68                        die "$RESOLVEMSG"
  69                fi
  70                printf "Committed: %0${prec}d" $msgnum
  71        else
  72                printf "Already applied: %0${prec}d" $msgnum
  73        fi
  74        echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
  75                                sed 's/^[a-f0-9]\+ //'`
  76
  77        prev_head=`git-rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat $dotest/cmt.$1)"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git-rev-parse --verify HEAD)
  90        cmt_name=$(git-symbolic-ref HEAD)
  91        msgnum=$(cat $dotest/msgnum)
  92        end=$(cat $dotest/end)
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                test -d "$GIT_DIR/rr-cache" && git-rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        rm -r "$dotest"
 120        echo "All done."
 121}
 122
 123is_interactive () {
 124        test -f "$dotest"/interactive ||
 125        while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 126        do
 127                shift
 128        done && test -n "$1"
 129}
 130
 131is_interactive "$@" && exec git-rebase--interactive "$@"
 132
 133while case "$#" in 0) break ;; esac
 134do
 135        case "$1" in
 136        --continue)
 137                git-diff-files --quiet || {
 138                        echo "You must edit all merge conflicts and then"
 139                        echo "mark them as resolved using git add"
 140                        exit 1
 141                }
 142                if test -d "$dotest"
 143                then
 144                        prev_head="`cat $dotest/prev_head`"
 145                        end="`cat $dotest/end`"
 146                        msgnum="`cat $dotest/msgnum`"
 147                        onto="`cat $dotest/onto`"
 148                        continue_merge
 149                        while test "$msgnum" -le "$end"
 150                        do
 151                                call_merge "$msgnum"
 152                                continue_merge
 153                        done
 154                        finish_rb_merge
 155                        exit
 156                fi
 157                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 158                exit
 159                ;;
 160        --skip)
 161                if test -d "$dotest"
 162                then
 163                        if test -d "$GIT_DIR/rr-cache"
 164                        then
 165                                git-rerere clear
 166                        fi
 167                        prev_head="`cat $dotest/prev_head`"
 168                        end="`cat $dotest/end`"
 169                        msgnum="`cat $dotest/msgnum`"
 170                        msgnum=$(($msgnum + 1))
 171                        onto="`cat $dotest/onto`"
 172                        while test "$msgnum" -le "$end"
 173                        do
 174                                call_merge "$msgnum"
 175                                continue_merge
 176                        done
 177                        finish_rb_merge
 178                        exit
 179                fi
 180                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 181                exit
 182                ;;
 183        --abort)
 184                if test -d "$GIT_DIR/rr-cache"
 185                then
 186                        git-rerere clear
 187                fi
 188                if test -d "$dotest"
 189                then
 190                        rm -r "$dotest"
 191                elif test -d .dotest
 192                then
 193                        rm -r .dotest
 194                else
 195                        die "No rebase in progress?"
 196                fi
 197                git reset --hard ORIG_HEAD
 198                exit
 199                ;;
 200        --onto)
 201                test 2 -le "$#" || usage
 202                newbase="$2"
 203                shift
 204                ;;
 205        -M|-m|--m|--me|--mer|--merg|--merge)
 206                do_merge=t
 207                ;;
 208        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 209                --strateg=*|--strategy=*|\
 210        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 211                case "$#,$1" in
 212                *,*=*)
 213                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 214                1,*)
 215                        usage ;;
 216                *)
 217                        strategy="$2"
 218                        shift ;;
 219                esac
 220                do_merge=t
 221                ;;
 222        -v|--verbose)
 223                verbose=t
 224                ;;
 225        -C*)
 226                git_am_opt=$1
 227                shift
 228                ;;
 229        -*)
 230                usage
 231                ;;
 232        *)
 233                break
 234                ;;
 235        esac
 236        shift
 237done
 238
 239# Make sure we do not have .dotest
 240if test -z "$do_merge"
 241then
 242        if mkdir .dotest
 243        then
 244                rmdir .dotest
 245        else
 246                echo >&2 '
 247It seems that I cannot create a .dotest directory, and I wonder if you
 248are in the middle of patch application or another rebase.  If that is not
 249the case, please rm -fr .dotest and run me again.  I am stopping in case
 250you still have something valuable there.'
 251                exit 1
 252        fi
 253else
 254        if test -d "$dotest"
 255        then
 256                die "previous dotest directory $dotest still exists." \
 257                        'try git-rebase < --continue | --abort >'
 258        fi
 259fi
 260
 261# The tree must be really really clean.
 262git-update-index --refresh || exit
 263diff=$(git-diff-index --cached --name-status -r HEAD)
 264case "$diff" in
 265?*)     echo "cannot rebase: your index is not up-to-date"
 266        echo "$diff"
 267        exit 1
 268        ;;
 269esac
 270
 271# The upstream head must be given.  Make sure it is valid.
 272upstream_name="$1"
 273upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 274    die "invalid upstream $upstream_name"
 275
 276# Make sure the branch to rebase onto is valid.
 277onto_name=${newbase-"$upstream_name"}
 278onto=$(git-rev-parse --verify "${onto_name}^0") || exit
 279
 280# If a hook exists, give it a chance to interrupt
 281if test -x "$GIT_DIR/hooks/pre-rebase"
 282then
 283        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 284                echo >&2 "The pre-rebase hook refused to rebase."
 285                exit 1
 286        }
 287fi
 288
 289# If the branch to rebase is given, first switch to it.
 290case "$#" in
 2912)
 292        branch_name="$2"
 293        git-checkout "$2" || usage
 294        ;;
 295*)
 296        if branch_name=`git symbolic-ref -q HEAD`
 297        then
 298                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 299        else
 300                branch_name=HEAD ;# detached
 301        fi
 302        ;;
 303esac
 304branch=$(git-rev-parse --verify "${branch_name}^0") || exit
 305
 306# Now we are rebasing commits $upstream..$branch on top of $onto
 307
 308# Check if we are already based on $onto, but this should be
 309# done only when upstream and onto are the same.
 310mb=$(git-merge-base "$onto" "$branch")
 311if test "$upstream" = "$onto" && test "$mb" = "$onto"
 312then
 313        echo >&2 "Current branch $branch_name is up to date."
 314        exit 0
 315fi
 316
 317if test -n "$verbose"
 318then
 319        echo "Changes from $mb to $onto:"
 320        # We want color (if set), but no pager
 321        GIT_PAGER='' git-diff --stat --summary "$mb" "$onto"
 322fi
 323
 324# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 325echo "First, rewinding head to replay your work on top of it..."
 326git-reset --hard "$onto"
 327
 328# If the $onto is a proper descendant of the tip of the branch, then
 329# we just fast forwarded.
 330if test "$mb" = "$branch"
 331then
 332        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 333        exit 0
 334fi
 335
 336if test -z "$do_merge"
 337then
 338        git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 339        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 340        exit $?
 341fi
 342
 343# start doing a rebase with git-merge
 344# this is rename-aware if the recursive (default) strategy is used
 345
 346mkdir -p "$dotest"
 347echo "$onto" > "$dotest/onto"
 348echo "$onto_name" > "$dotest/onto_name"
 349prev_head=`git-rev-parse HEAD^0`
 350echo "$prev_head" > "$dotest/prev_head"
 351
 352msgnum=0
 353for cmt in `git-rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
 354do
 355        msgnum=$(($msgnum + 1))
 356        echo "$cmt" > "$dotest/cmt.$msgnum"
 357done
 358
 359echo 1 >"$dotest/msgnum"
 360echo $msgnum >"$dotest/end"
 361
 362end=$msgnum
 363msgnum=1
 364
 365while test "$msgnum" -le "$end"
 366do
 367        call_merge "$msgnum"
 368        continue_merge
 369done
 370
 371finish_rb_merge